#Compile Exe "gbsnippetscompiler.exe"
#Dim All
#Debug Error On
#Debug Display On
#Include "Win32API.inc"
#Resource Icon logo, "gbsnippetscompiler.ico"

%IDC_All      = 500
%IDC_Success  = 501
%IDC_Failure  = 502
%IDC_Button9  = 504
%IDC_Button10 = 505
%IDC_TextBox  = 506
%IDC_Button9All  = 507
%IDC_Button10All = 508
%IDC_NoExample   = 509
%IDC_StatusBar   = 510
%IDC_Compiler9   = 511
%IDC_Compiler10  = 512
%IDC_ButtonLog   = 513
%IDC_LSuccess    = 514
%IDC_LFailure    = 515
%IDC_LNoExample  = 516
%IDC_Reference   = 517
%IDC_LReference  = 518
%IDC_LAll        = 519
%IDC_PrintFail   = 520

Global hDlg,hFont As Dword, D() As String, testBAS$
Global PathCompile, PathInclude, PathCompileX, PathIncludeX As String
Global CMDString, tempBAS, tempEXE, tempLOG As String, iReturn As Long
Global qFreq, qStart, qStop As Quad

Function PBMain() As Long
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
             Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop
   Font New "Courier New", 10 To hFont
   Dialog New Pixels, 0, "gbSnippets Reader",50,400,900,1020, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   Control Add Button, hDlg, %IDC_Button9, "Compile (9)", 10,10,70,20
   Control Add Button, hDlg, %IDC_Button10, "Compile (10)", 90,10,70,20
   Control Add Button, hDlg, %IDC_Button9All, "Compile All (9)", 185,10,85,20
   Control Add Button, hDlg, %IDC_Button10All, "Compile All (10)", 280,10,85,20
   Control Add ListBox, hDlg, %IDC_All, , 10,50,240,350, %LBS_Notify Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
   Control Add ListBox, hDlg, %IDC_Success, , 260,50,150,350, %LBS_Notify Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
   Control Add ListBox, hDlg, %IDC_Failure, , 420,50,150,350, %LBS_Notify Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
   Control Add ListBox, hDlg, %IDC_NoExample, , 580,50,150,350, %LBS_Notify Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
   Control Add ListBox, hDlg, %IDC_Reference, , 740,50,150,350, %LBS_Notify Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge

   Control Add Label, hDlg, %IDC_LAll, "All Snippets", 10,35,100,15
   Control Add Label, hDlg, %IDC_LSuccess, "Success", 260,35,100,15
   Control Add Label, hDlg, %IDC_LFailure, "Failure", 420,35,100,15
   Control Add Label, hDlg, %IDC_LNoExample, "No Example", 580,35,100,15
   Control Add Label, hDlg, %IDC_LReference, "Reference", 740,35,100,15

   Control Add Option, hDlg, %IDC_Compiler9, "PBWin9 (DClk)",  410,10,100,15
   Control Add Option, hDlg, %IDC_Compiler10, "PBWin10 (DClk)", 510, 10,100,15
   Control Set Option hDlg, %IDC_Compiler9, %IDC_Compiler9, %IDC_Compiler10

   Control Add Button, hDlg, %IDC_ButtonLog, "Show Log", 640,10,70,20
   Control Add Button, hDlg, %IDC_PrintFail, "Print Failure List", 730,10,90,20

   Control Add TextBox, hDlg, %IDC_TextBox, "", 10,390,880,600, style&, %WS_Ex_ClientEdge
   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Control Set Font hDlg, %IDC_TextBox, hFont
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local i,iResult,iCount As Long, temp$
   Select Case Cb.Msg
      Case %WM_InitDialog
         QueryPerformanceFrequency qFreq
         tempBAS = Exe.Path$ + "temp_reader.bas"
         tempEXE = Exe.Path$ + "temp_reader.exe"
         tempLOG = Exe.Path$ + "temp_reader.log"
         LoadFile("reader.gbs")
         DisplayInListBox

         ListBox Get Count hDlg, %IDC_All To iResult
         Statusbar Set Text hDlg, %IDC_StatusBar,1,0,"Snippets Found: " + Str$(iResult)

         Control Set Focus hDlg, %IDC_All
         ListBox Select hDlg, %IDC_All, 1
         ListBox Get User hDlg, %IDC_All, 1 To iResult
         Control Set Text hDlg, %IDC_TextBox, D(iResult)

         PathCompile="c:\pbwin90\bin\pbwin.exe"
         PathInclude="c:\pbwin90\winapi\"
         PathCompileX="c:\pbwin10\bin\pbwin.exe"
         PathIncludeX="c:\pbwin10\winapi\"
         testBAS$ = "'Compilable Example:" + $CrLf + "Function PBMain() As Long" + $CrLf + "? " + $Dq + "hello" + $Dq + $CrLf + "End Function"

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_All
               Select Case Cb.CtlMsg
                  Case %LBN_SelChange
                     ListBox Get Select hDlg, %IDC_All To iResult
                     ListBox Get User hDlg, %IDC_All, iResult To iResult
                     Control Set Text hDlg, %IDC_TextBox, D(iResult)
                  Case %LBN_DblClk
                     ListBox Get Select hDlg, %IDC_All To iResult
                     ListBox Get User hDlg, %IDC_All, iResult To iResult
                     Control Get Check hdlg, %IDC_Compiler9 To i
                     If i Then
                        CompileRun D(iResult), PathCompile, PathInclude, 1, 1
                     Else
                        CompileRun D(iResult), PathCompileX, PathIncludeX, 1, 1
                     End If
               End Select

            Case %IDC_ButtonLog
               iReturn = Shell("notepad.exe " + tempLOG, 1)   'does not wait

            Case %IDC_PrintFail
               ListBox Get Count hDlg, %IDC_Failure To iCount
               XPrint Attach Default
               For i = 1 To iCount
                  ListBox Get Text hDlg, %IDC_Failure, i To temp$
                  If i Mod 4 = 0 Then
                     XPrint Print Left$(temp$,11)
                  Else
                     XPrint Print Left$(temp$,11),
                  End If
               Next i
               XPrint Close

            Case %IDC_Button9
               ListBox Get Select hDlg, %IDC_All To iResult
               ListBox Get User hDlg, %IDC_All, iResult To iResult
               iResult = CompileRun( D(iResult), PathCompile, PathInclude, 0,0)
               ? Choose$(iResult, "Success", "Error", "No Example", "Reference")

            Case %IDC_Button10
               ListBox Get Select hDlg, %IDC_All To iResult
               ListBox Get User hDlg, %IDC_All, iResult To iResult
               iResult = CompileRun( D(iResult), PathCompileX, PathIncludeX, 0,0)
               ? Choose$(iResult, "Success", "Error", "No Example", "Reference")

            Case %IDC_Button9All
               QueryPerformanceCounter qStart
               ResetAll
               ListBox Get Count hDlg, %IDC_All To iCount
               RedrawOff
               For i = 1 To iCount
                  ListBox Get Text hDlg, %IDC_All, i To temp$
                  ListBox Get User hDlg, %IDC_All, i To iResult
                  iResult = CompileRun(D(iResult), PathCompile, PathInclude, 0,0)
                  Select Case iResult
                     Case 1 : ListBox Add hDlg, %IDC_Success, temp$
                     Case 2 : ListBox Add hDlg, %IDC_Failure, temp$
                     Case 3
                        If Mid$(temp$,11)= "." Then
                           ListBox Add hDlg, %IDC_NoExample, temp$
                        Else
                           ListBox Add hDlg, %IDC_Reference, temp$
                        End If
                  End Select
               Next i
               RedrawOn
               ShowCounts
               QueryPerformanceCounter qStop
               Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
               Beep
            Case %IDC_Button10All
               QueryPerformanceCounter qStart
               Resetall
               ListBox Get Count hDlg, %IDC_All To iCount
               RedrawOff
               For i = 1 To iCount
                  ListBox Get Text hDlg, %IDC_All, i To temp$
                  ListBox Get User hDlg, %IDC_All, i To iResult
                  iResult = CompileRun(D(iResult), PathCompileX, PathIncludeX, 0,0)
                  Select Case iResult
                     Case 1 : ListBox Add hDlg, %IDC_Success, temp$
                     Case 2 : ListBox Add hDlg, %IDC_Failure, temp$
                     Case 3
                        If Mid$(temp$,11)= "." Then
                           ListBox Add hDlg, %IDC_NoExample, temp$
                        Else
                           ListBox Add hDlg, %IDC_Reference, temp$
                        End If
                  End Select
               Next i
               RedrawOn
               ShowCounts
               QueryPerformanceCounter qStop
               Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
               Beep
         End Select
   End Select
End Function

Sub DisplayInListBox
   Local i,j,iCount As Long, temp As String, s As String
   For i = 0 To UBound(D)
      j = InStr(D(i),"gbs" + "_")
      If j Then
         Incr iCount
         ListBox Add hDlg, %IDC_All, Mid$(D(i),j,9) + "  " + Parse$(D(i),$CrLf,3)
         ListBox Set User hDlg, %IDC_All, iCount, i
      Else
         If Val(Parse$(D(i),$CrLf,2)) >= Val(Parse$(D(i+1),$CrLf,2)) Then   'check for children
            Incr iCount
            ListBox Add hDlg, %IDC_All, "---" + Parse$(D(i),$CrLf,3)
            ListBox Set User hDlg, %IDC_All, iCount, i
         End If
      End If
   Next i
End Sub

Sub LoadFile(fName$)
   Local i As Long, temp As String
   Open fName$ For Binary As #1
   Get$ #1, Lof(1), temp
   Close #1
   ReDim D(ParseCount(temp$, "++-"+"-;;")-1)
   Parse temp, D(), "++-"+"-;;"
End Sub

Function CompileRun(ByVal temp$, ByVal pCompile As String, ByVal pInclude As String, FlagShowError As Long, FlagRun As Long) As Long
   Local CMDString As String, iReturn As Long

   iReturn = InStr(temp$, "'Compilable Example:")
   If iReturn Then
      temp$ = Mid$(temp$,iReturn) 'get compilable example
      Open tempBAS For Output As #1 : Print #1, temp$ : Close #1  'save Compilable Example
      CmdString = pCompile + " /I" + $Dq + pInclude + $Dq + " " + $Dq + tempBAS + $Dq + "/L /Q"
      Shell CmdString, 1     'make EXE, wait for compiler to complete
      Open tempLOG For Binary As #1 : Get$ #1, Lof(1), temp$ : Close #1
      If InStr(LCase$(temp$),"error ") Then  'ask user if wants to open log file
         'error during compilation
         If FlagShowError Then
            If MsgBox ("Error during compilation. Open compile log?", %MB_OkCancel Or %MB_IconInformation, "Compile and Execute") = %IdOk Then
               iReturn = Shell("notepad.exe " + tempLOG, 1)   'does not wait
            End If
         End If
         Function = 2   '2 compilation error
      Else
         'no error during compilation
         If FlagRun Then iReturn = Shell(tempEXE)   'run EXE, not wait
         Function = 1   '1 compilation succeeded
      End If
   Else
       If FlagShowError Then MsgBox "Compilable example not found in snippet!", %MB_Ok + %MB_IconInformation, "Compile & Run"
       Function = 3   'compilable example not found in snippet
   End If
End Function

Sub ShowCounts
   Local i As Long
   ListBox Get Count hDlg, %IDC_All To i
   Control Set Text hDlg, %IDC_LAll, "All " + Str$(i)
   ListBox Get Count hDlg, %IDC_Success To i
   Control Set Text hDlg, %IDC_LSuccess, "Success " + Str$(i)
   ListBox Get Count hDlg, %IDC_Failure To i
   Control Set Text hDlg, %IDC_LFailure, "Failure " + Str$(i)
   ListBox Get Count hDlg, %IDC_NoExample To i
   Control Set Text hDlg, %IDC_LNoExample, "No Example " + Str$(i)
   ListBox Get Count hDlg, %IDC_Reference To i
   Control Set Text hDlg, %IDC_LReference, "Reference " + Str$(i)
End Sub

Sub ResetAll
   ListBox Reset hDlg, %IDC_Success
   ListBox Reset hDlg, %IDC_Failure
   ListBox Reset hDlg, %IDC_NoExample
   ListBox Reset hDlg, %IDC_Reference
End Sub

Sub RedrawOff
   SendMessage GetDlgItem(hDlg, %IDC_Success), %WM_SETREDRAW, 0, 0
   SendMessage GetDlgItem(hDlg, %IDC_Failure), %WM_SETREDRAW, 0, 0
   SendMessage GetDlgItem(hDlg, %IDC_NoExample), %WM_SETREDRAW, 0, 0
   SendMessage GetDlgItem(hDlg, %IDC_Reference), %WM_SETREDRAW, 0, 0
End Sub

Sub RedrawON
   SendMessage GetDlgItem(hDlg, %IDC_Success), %WM_SETREDRAW, 1, 0
   SendMessage GetDlgItem(hDlg, %IDC_Failure), %WM_SETREDRAW, 1, 0
   SendMessage GetDlgItem(hDlg, %IDC_NoExample), %WM_SETREDRAW, 1, 0
   SendMessage GetDlgItem(hDlg, %IDC_Reference), %WM_SETREDRAW, 1, 0
End Sub
